%define major 1
%define libname %mklibname audit %{major}
%define devname %mklibname audit -d
%define sdevname %mklibname audit -d -s

%define auparsemajor 0
%define auparselibname %mklibname auparse %{auparsemajor}
%define auparsedevname %mklibname auparse -d
%define auparsesdevname %mklibname auparse -d -s

%define _libexecdir %{_prefix}/libexec

Summary:	User-space tools for Linux 2.6 kernel auditing
Name:		audit
Version:	2.5.2
Release:	1
License:	LGPLv2+
Group:		System/Base
Url:		http://people.redhat.com/sgrubb/audit/
Source0:	http://people.redhat.com/sgrubb/audit/%{name}-%{version}.tar.gz
Source100:	%{name}.rpmlintrc

BuildRequires:	intltool
BuildRequires:	libtool
BuildRequires:	swig
BuildRequires:	glibc-devel
BuildRequires:	gettext-devel
BuildRequires:	openldap-devel
BuildRequires:	tcp_wrappers-devel
BuildRequires:	pkgconfig(libcap-ng)
BuildRequires:	pkgconfig(libprelude)
BuildRequires:	pkgconfig(python)
BuildRequires:	pkgconfig(python3)
BuildRequires:	systemd-units
BuildRequires:	kernel-headers >= 1:2.6.30

Requires:	tcp_wrappers
# has the mandriva-simple-auth pam config file we link to
Requires:	usermode-consoleonly >= 1.92-4
Requires:	%{auparselibname} >= %{version}
Requires(post):	chkconfig
Requires(post):	coreutils
Requires(post,preun,postun):	systemd-units
Requires:	initscripts > 2:9.39
Requires(post,preun):	rpm-helper
Conflicts:	audispd-plugins < 1.7.11

%description
The audit package contains the user space utilities for storing and searching
the audit records generate by the audit subsystem in the Linux 2.6 kernel.

%files
%doc README COPYING rules/*rules init.d/auditd.cron
%attr(750,root,root) %dir %{_libexecdir}/initscripts/legacy-actions/auditd
%attr(750,root,root) %{_libexecdir}/initscripts/legacy-actions/auditd/resume
%attr(750,root,root) %{_libexecdir}/initscripts/legacy-actions/auditd/rotate
%attr(750,root,root) %{_libexecdir}/initscripts/legacy-actions/auditd/stop
%attr(750,root,root) %{_libexecdir}/initscripts/legacy-actions/auditd/restart
%attr(750,root,root) %{_libexecdir}/initscripts/legacy-actions/auditd/condrestart
%attr(644,root,root) %{_unitdir}/auditd.service
%attr(0750,root,root) %dir %{_sysconfdir}/audit
%attr(0750,root,root) %dir %{_sysconfdir}/audit/rules.d
%attr(0750,root,root) %dir %{_sysconfdir}/audisp
%attr(0750,root,root) %dir %{_sysconfdir}/audisp/plugins.d
%attr(0750,root,root) %dir %{_libdir}/audit
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audit/auditd.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audit/rules.d/audit.rules
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/audispd.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/plugins.d/af_unix.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/plugins.d/syslog.conf
%attr(0750,root,root) /sbin/audispd
%attr(0750,root,root) /sbin/auditctl
%attr(0750,root,root) /sbin/auditd
%attr(0750,root,root) /sbin/autrace
%attr(0755,root,root) /sbin/aureport
%attr(0755,root,root) /sbin/ausearch
%attr(0750,root,root) /sbin/augenrules
%attr(0755,root,root) %{_bindir}/aulastlog
%attr(0755,root,root) %{_bindir}/aulast
%attr(0755,root,root) %{_bindir}/ausyscall
%attr(0755,root,root) %{_bindir}/auvirt
%attr(0644,root,root) %{_mandir}/man5/audispd.conf.5*
%attr(0644,root,root) %{_mandir}/man5/auditd.conf.5*
%attr(0644,root,root) %{_mandir}/man5/ausearch-expression.5*
%attr(0644,root,root) %{_mandir}/man7/audit.rules.7*
%attr(0644,root,root) %{_mandir}/man8/audispd.8*
%attr(0644,root,root) %{_mandir}/man8/auditctl.8*
%attr(0644,root,root) %{_mandir}/man8/auditd.8*
%attr(0644,root,root) %{_mandir}/man8/aulast.8*
%attr(0644,root,root) %{_mandir}/man8/aulastlog.8*
%attr(0644,root,root) %{_mandir}/man8/auvirt.8*
%attr(0644,root,root) %{_mandir}/man8/augenrules.8*
%attr(0644,root,root) %{_mandir}/man8/aureport.8*
%attr(0644,root,root) %{_mandir}/man8/ausearch.8*
%attr(0644,root,root) %{_mandir}/man8/ausyscall.8*
%attr(0644,root,root) %{_mandir}/man8/autrace.8*
%attr(0700,root,root) %dir %{_var}/log/audit

%post
%systemd_post auditd.service

%preun
%systemd_preun auditd.service

%postun
%systemd_postun auditd.service

#----------------------------------------------------------------------------

%package -n libaudit-common
Summary:	Main libraries for %{name}
Group:		System/Libraries
Conflicts:	audit < 2.0
Conflicts:	%{_lib}audit1 < 2.3.2-5

%description -n libaudit-common
This package contains the main libraries for %{name}.

%files -n libaudit-common
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/libaudit.conf
%attr(0644,root,root) %{_mandir}/man5/libaudit.conf.5*

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Main libraries for %{name}
Group:		System/Libraries
Conflicts:	audit < 2.0
Requires:	libaudit-common >= %{EVRD}

%description -n %{libname}
This package contains the main libraries for %{name}.

%files -n %{libname}
/%{_lib}/libaudit.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	libaudit-devel = %{EVRD}
Provides:	audit-devel = %{EVRD}
Provides:	audit-libs-devel = %{EVRD}

%description -n %{devname}
This package contains development files for %{name}.

%files -n %{devname}
%doc ChangeLog contrib/skeleton.c contrib/plugin
%{_libdir}/libaudit.so
%{_includedir}/libaudit.h
%{_mandir}/man3/audit_*
%{_mandir}/man3/ausearch_*
%{_mandir}/man3/get_auditfail_action.3*
%{_mandir}/man3/set_aumessage_mode.3*
%{_libdir}/pkgconfig/audit.pc
%{_datadir}/aclocal/audit.m4

#----------------------------------------------------------------------------

%package -n %{sdevname}
Summary:	Static libraries for %{name}
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	audit-static-devel = %{EVRD}
Provides:	audit-libs-static-devel = %{EVRD}

%description -n %{sdevname}
This package contains static libraries for %{name} used for development.

%files -n %{sdevname}
%{_libdir}/libaudit.a

#----------------------------------------------------------------------------

%package -n %{auparselibname}
Summary:	Main libraries for %{name}
Group:		System/Libraries
Conflicts:	%{mklibname audit 0} <= 1.7.13

%description -n %{auparselibname}
This package contains the main auparse libraries for %{name}.

%files -n %{auparselibname}
/%{_lib}/libauparse.so.%{auparsemajor}*

#----------------------------------------------------------------------------

%package -n %{auparsedevname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{auparselibname} = %{EVRD}
Provides:	auparse-devel = %{EVRD}
Conflicts:	%{mklibname audit 0 -d} <= 1.7.13

%description -n %{auparsedevname}
This package contains development files for %{name}.

%files -n %{auparsedevname}
%doc ChangeLog contrib/skeleton.c contrib/plugin
%{_libdir}/libauparse.so
%{_includedir}/auparse-defs.h
%{_includedir}/auparse.h
%{_mandir}/man3/auparse_*
%{_libdir}/pkgconfig/auparse.pc

#----------------------------------------------------------------------------

%package -n %{auparsesdevname}
Summary:	Static libraries for %{name}
Group:		Development/C
Requires:	%{auparsedevname} = %{EVRD}
Provides:	auparse-static-devel = %{EVRD}
Conflicts:	%{mklibname audit 0 -d -s} <= 1.7.13

%description -n %{auparsesdevname}
This package contains static libraries for %{name} used for development.

%files -n %{auparsesdevname}
%{_libdir}/libauparse.a

#----------------------------------------------------------------------------

%package -n python-audit
Summary:	Python bindings for %{name}
Group:		Development/Python

%description -n python-audit
This package contains python bindings for %{name}.

%files -n python-audit
%{python_sitearch}/*.so
%{python_sitearch}/audit.p*

%package -n python3-audit
Summary:	Python3 bindings for %{name}
Group:		Development/Python

%description -n python3-audit
This package contains python3 bindings for %{name}.

%files -n python3-audit
%{python3_sitearch}/*.so
%{python3_sitearch}/audit.p*

#----------------------------------------------------------------------------

%package -n audispd-plugins
Summary:	Plugins for the audit event dispatcher
Group:		System/Base
Requires:	%{name} = %{EVRD}
Requires:	%{libname} = %{EVRD}
Requires:	openldap

%description -n audispd-plugins
The audispd-plugins package provides plugins for the real-time interface to the
audit system, audispd. These plugins can do things like relay events to remote
machines or analyze events for suspicious behavior.

%files -n audispd-plugins
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/audisp-prelude.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/audisp-remote.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/plugins.d/audispd-zos-remote.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/plugins.d/au-prelude.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/plugins.d/au-remote.conf
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/audisp/zos-remote.conf
%attr(0750,root,root) /sbin/audispd-zos-remote
%attr(0750,root,root) /sbin/audisp-prelude
%attr(0750,root,root) /sbin/audisp-remote
%attr(0644,root,root) %{_mandir}/man5/audisp-prelude.conf.5*
%attr(0644,root,root) %{_mandir}/man5/audisp-remote.conf.5*
%attr(0644,root,root) %{_mandir}/man5/zos-remote.conf.5*
%attr(0644,root,root) %{_mandir}/man8/audispd-zos-remote.8*
%attr(0644,root,root) %{_mandir}/man8/audisp-prelude.8*
%attr(0644,root,root) %{_mandir}/man8/audisp-remote.8*
%attr(0750,root,root) %dir %{_var}/spool/audit

#----------------------------------------------------------------------------

%prep
%setup -q

sed -i -e 's|initdir = /usr/lib/systemd/system|initdir = %{_unitdir}|' init.d/Makefile.am

find -type d -name ".libs" | xargs rm -rf

%build
%serverbuild
autoreconf -f -v --install

%configure2_5x \
	--sbindir=/sbin \
	--libdir=/%{_lib} \
	--with-prelude \
	--with-libwrap \
	--with-python=yes \
	--with-python3=yes \
	--with-libcap-ng=yes \
	--enable-systemd

%make

%install
install -d %{buildroot}%{_var}/log/audit
install -d %{buildroot}%{_libdir}/audit
install -d %{buildroot}%{_var}/spool/audit
install -d %{buildroot}%{_sysconfdir}/audit/rules.d

%makeinstall_std

# Disable audit by default
install -m640 rules/10-no-audit.rules %{buildroot}%{_sysconfdir}/audit/rules.d/audit.rules

install -d %{buildroot}/%{_libdir}
install -d %{buildroot}/%{_libdir}/pkgconfig
# This winds up in the wrong place when libtool is involved
mv %{buildroot}/%{_lib}/libaudit.a %{buildroot}%{_libdir}/
mv %{buildroot}/%{_lib}/libauparse.a %{buildroot}%{_libdir}/
mv %{buildroot}/%{_lib}/pkgconfig/audit.pc %{buildroot}%{_libdir}/pkgconfig/
mv %{buildroot}/%{_lib}/pkgconfig/auparse.pc %{buildroot}%{_libdir}/pkgconfig/
curdir=`pwd`
cd %{buildroot}/%{_libdir}
LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libaudit.so.%{major}.*.*\``
ln -s ../../%{_lib}/$LIBNAME libaudit.so
LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libauparse.so.%{auparsemajor}.*.*\``
ln -s ../../%{_lib}/$LIBNAME libauparse.so
cd $curdir

# unneeded files
rm -f %{buildroot}/%{_lib}/*.so
rm -f %{buildroot}/%{_lib}/*.la
rm -f %{buildroot}%{python3_sitearch}/*.{a,la}
rm -f %{buildroot}%{python_sitearch}/*.{a,la}

%changelog

* Fri Jun 03 2016 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 2.5.2-1
- (7bf2eed) Updated to version 2.5.2 with additional adjustments
- (7bf2eed) Besides the update per se, the following was done:
- (7bf2eed) 1. Support systemd unconditionally
- (7bf2eed) 2. Build Python3 bindings as well
- (7bf2eed) 3. Disable audit by default.


